'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var preact = require('preact');
var BooleanInput = _interopDefault(require('@hashicorp/hashi-boolean-input'));
var withValidation = _interopDefault(require('@hashicorp/hashi-with-validation'));

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ValidatedBooleanInput = withValidation(BooleanInput);

/**
 * Hashicorp uses this privacy poliy checkbox across a range of forms including
 * sales, webinar and trial forms.
 * @prop {Function} [onValidityChange] - function called with true/false when all
 * checkbox is valid (checked).
 * @prop {Boolean} forceValidate - if set to true, will force all fields to run
 * their validate functions
 * @prop {Boolean} on_dark - adjust css for dark backgrounds
 */

var PrivacyCheckbox = function (_Component) {
  _inherits(PrivacyCheckbox, _Component);

  function PrivacyCheckbox(props) {
    _classCallCheck(this, PrivacyCheckbox);

    var _this = _possibleConstructorReturn(this, (PrivacyCheckbox.__proto__ || Object.getPrototypeOf(PrivacyCheckbox)).call(this, props));

    _this.state = {
      privacyValidity: null
    };
    return _this;
  }

  _createClass(PrivacyCheckbox, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (this.state.privacyValidity !== prevState.privacyValidity) {
        this.props.onValidityChange && this.props.onValidityChange(this.state.privacyValidity);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return preact.h(ValidatedBooleanInput, {
        label: 'I agree to HashiCorp\u2019s <a href=\'/privacy\' target=\'_blank\'>Privacy Policy</a>.',
        name: 'privacyPolicy',
        on_dark: this.props.on_dark,
        onValidityChange: function onValidityChange(s) {
          return _this2.setState({ privacyValidity: s !== 'error' });
        },
        forceValidate: this.props.forceValidate,
        validate: function validate(value) {
          if (value) {
            return { status: 'success', message: null };
          } else {
            return {
              status: 'error',
              message: 'You must agree to the privacy policy to continue.'
            };
          }
        }
      });
    }
  }]);

  return PrivacyCheckbox;
}(preact.Component);

module.exports = PrivacyCheckbox;
