import { h } from 'preact'
import { expect } from 'chai'
import PrivacyCheckbox from './index'
import propsSpec from './props'

testComponent(
  () => PrivacyCheckbox,
  { props: propsSpec },
  ({ testTagAndClass, render, renderDeep, propValue }) => {
    testTagAndClass('div', 'g-validation-container null')

    it('should toggle checkbox', () => {
      const wrapper = renderDeep()
      expect(
        wrapper.find(<input type="checkbox" />)[0].attributes.value
      ).to.equal(false)
      wrapper
        .find(<input type="checkbox" />)
        .simulate('change', { target: { checked: true } })
      expect(
        wrapper.find(<input type="checkbox" />)[0].attributes.value
      ).to.equal(true)
    })
  }
)
